/**
 * *****************************************************************************
 * Copyright (C) 2017 ELIXIR ES, Spanish National Bioinformatics Institute (INB)
 * and Barcelona Supercomputing Center (BSC)
 *
 * Modifications to the initial code base are copyright of their respective
 * authors, or their employers as appropriate.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301  USA
 *****************************************************************************
 */

package es.bsc.inb.elixir.openebench.debian;

import es.bsc.inb.elixir.openebench.model.tools.Tool;
import es.bsc.inb.elixir.openebench.repository.OpenEBenchAlambiqueEndpoint;
import es.bsc.inb.elixir.openebench.repository.OpenEBenchEndpoint;
import es.bsc.inb.elixir.openebench.repository.OpenEBenchRepository;
import java.io.IOException;
import java.net.URI;
import java.time.LocalTime;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * The bioconda data importer.
 * 
 * @author Dmitry Repchevsky
 */

public class DebianRepositoryImporter {
    
    private OpenEBenchRepository repository;
    private OpenEBenchAlambiqueEndpoint alambique;
    
    public DebianRepositoryImporter() {}

    public DebianRepositoryImporter(String username, String password) {
        repository = new OpenEBenchRepository(username, password);
        alambique = new OpenEBenchAlambiqueEndpoint(username, password);
    }
    
    public void load(
            final String git, 
            final String branch, 
            final String path) {
        
        boolean exception = false;
        
        final Set<URI> ids = new HashSet<>();
        
        try (DebianGitRepositoryIterator iter = new DebianGitRepositoryIterator(git, branch, path)) {
            while (iter.hasNext()) {
                final Map<String, Object> attributes = iter.next();
                if (attributes != null) {
                    final Tool tool;
                    try {
                        tool = DebianConverter.convert(attributes);
                    } catch (Exception ex) {
                        ex.printStackTrace();
                        exception = true;
                        Logger.getLogger(DebianRepositoryImporter.class.getName()).log(Level.SEVERE, attributes.getOrDefault("name", "no name").toString(), ex.getMessage());
                        continue;
                    }
                    try {
                        System.out.println(LocalTime.now() + ": (PUT) " + tool.id);
                        if (repository != null) {
                            repository.patch(tool);
                        }
                        ids.add(tool.id);
                    } catch (Exception ex) {
                        exception = true;
                        Logger.getLogger(DebianRepositoryImporter.class.getName()).log(Level.SEVERE, tool.id.toString(), ex);
                    }
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(DebianRepositoryImporter.class.getName()).log(Level.SEVERE, ex.getMessage());
        }
        
//        if (!exception) {
//            for (Tool tool : OpenEBenchRepository.getTools().values()) {
//                final Boolean deprecated = tool.getDepricated();
//
//                final String id = tool.id.toString();
//                if (!id.startsWith(OpenEBenchEndpoint.TOOL_URI_BASE)) {
//                    Logger.getLogger(BiocondaRepositoryImporter.class.getName()).log(Level.WARNING, "dubious id: {0}", id);
//                    continue;
//                }
//                if (id.regionMatches(OpenEBenchEndpoint.TOOL_URI_BASE.length(), "biotools:", 0, 9)) {
//                    try {
//                        if (ids.contains(tool.id)) {
//                            if (Boolean.TRUE.equals(deprecated)) {
//                                System.out.println("> REMOVE DEPRECATE: " + tool.id);
//                                tool.setDepricated(null);
//                                if (repository != null) {
//                                    repository.put(tool);
//                                }
//                            }
//                        } else if (!Boolean.TRUE.equals(deprecated)) {
//                            tool.setDepricated(true);
//
//                            System.out.println("> DEPRECATE: " + tool.id);
//                            if (repository != null) {
//                                repository.patch(tool);
//                            }
//                        }
//                    } catch (IOException ex) {
//                        Logger.getLogger(BiocondaRepositoryImporter.class.getName()).log(Level.SEVERE, null, ex);
//                    }
//                }
//            }
//        }
    }
}
